/****************************************************************************
*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License                  *
*   For further information, please see LICENSE.TXT                         *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
*   Copyright (c) 1985, 1987, 1990, 1991  Digital Research Inc.		    *
*   All rights reserved.						    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: m:/davinci/users//groups/panther/aes/rcs/gemasync.c 4.1 92/01/06 11:58:46 sbc Exp $
* $Log:	gemasync.c $
 * Revision 4.1  92/01/06  11:58:46  sbc
 * Misc Housekeeping
 * 
 * Revision 4.0  91/09/05  11:40:03  system
 * Prototyping and cleanup plus fix to file selector
 * 
*/

/****************************************************************************
* File:		gemasync.c
*
* Description:	
*
* Build Info:	ndmake -f aes.mak
*
*****************************************************************************/

/*	GEMASYNC.C	1/27/84 - 09/12/85	Lee Jay Lorenzen	*/
/*	merge High C vers. w. 2.2 & 3.0		8/19/87		mdf	*/ 
/*	Add typecasts to clear up warnings in TurboC		RSF	*/
/*	Fix open comment that kept a statement commented out	RSF	*/

/*
*	-------------------------------------------------------------
*	GEM Application Environment Services		  Version 2.3
*	Serial No.  XXXX-0000-654321		  All Rights Reserved
*	Copyright (C) 1987			Digital Research Inc.
*	-------------------------------------------------------------
*/

#include "portab.h"
#include "machine.h"
#include "struct.h"
#include "basepage.h"
#include "obdefs.h"
#include "gemlib.h"
#include "cproto.h"
#include "aproto.h"


EXTERN UWORD	button, xrat, yrat;


MLOCAL	VOID
signal(EVB *e)
{
	REG PD		*p, *p1, *q1;

	p = (PD *) e->e_pd;
	p->p_evflg |= e->e_mask;
						/* off the not-ready	*/
						/*   list 		*/
	for (p1 = (q1 = (PD *) &nrl)->p_link; (p1 != p) && (p1);
	  p1 = (q1=p1)->p_link);
	if ( p != rlr )
	{
	  if ( p->p_evflg & p->p_evwait)
	  {
	    if ( p1 )
	    {
	      p1->p_stat &= ~WAITIN;
						/* onto the drl		*/
	      q1->p_link = p1->p_link;
	      p1->p_link = drl;
	      drl = p1;
	    }
	  }
	}
}


	VOID
azombie(e, ret)
	REG EVB		*e;
	UWORD		ret;
{
						/* must be called with	*/
						/*   dispatching off 	*/
	e->e_return = MAKELONG( button, ret ) ;
	e->e_parm = MAKELONG( xrat, yrat );

	e->e_link = zlr;
	if ( zlr )
	  zlr->e_pred = e;
	e->e_pred = (EVB*)((BYTE*)&zlr - elinkoff);	/* (RSF)typecast */
	zlr = e;
	e->e_flag = COMPLETE;
	signal(e);
}


	VOID
evinsert(e, root)
	REG EVB		*e;
	EVB		**root;
{
	REG EVB		*p, *q;
						/* insert event block	*/
						/*   on list 		*/
	q = (EVB*)((BYTE *) root - elinkoff) ;  /* (RSF) typecast*/
	p = *root;
	e->e_pred = q;
	q->e_link = e;
	e->e_link = p;
	if ( p )
	  p->e_pred = e;
}

	VOID
takeoff(REG EVB *p)
{
	REG LONG	c;

						/* take event p off	*/
						/*   e_link list, must 	*/
						/*   be NODISP 		*/
	p->e_pred->e_link = p->e_link;
	if (p->e_link)
	{
	  p->e_link->e_pred = p->e_pred;
	  if (p->e_flag & EVDELAY)
	  {
	    c = (LONG) p->e_link->e_parm;
	    c += (LONG) p->e_parm;
	    p->e_link->e_parm = (LONG) c;
	  }
	}
	p->e_nextp = eul;
	eul = p;
}


	EVSPEC
mwait(mask)
	EVSPEC		mask;
{
	rlr->p_evwait = mask;
	if ( !(mask & rlr->p_evflg) )
	{
	  rlr->p_stat |= WAITIN;
	  dsptch();
	}
	return(rlr->p_evflg);
}

	EVSPEC 
iasync(afunc, aparm)
	WORD		afunc;
	REG LONG	aparm;
{
	REG EVB		*e;
						/* get an evb		*/
	if ((e = eul) != 0)
	{
	  eul = eul->e_nextp;
	  memset( (BYTE*)e, 0, sizeof(EVB) );
	}
						/* put in on list	*/
	e->e_nextp = rlr->p_evlist;
	rlr->p_evlist = e;
	e->e_pd = (BYTE *) rlr;
	e->e_pred = (EVB*)0;			/* (RSF) typecast and   */
	e->e_flag = 0;				/*	split statement	*/
						/* find a free bit in	*/
						/*   in the mask	*/
	e->e_mask = afunc;
	rlr->p_evbits |= e->e_mask;

	switch(afunc)
	{
	  case MU_KEYBD: akbin(e);		break;
	  case MU_BUTTON:abutton(e,aparm);	break;
	  case MU_M1:
	  case MU_M2:	 amouse(e,aparm);	break;
	  case MU_MESAG: aqueue(FALSE,e,aparm); break;
	  case MU_TIMER: adelay(e,aparm);	break;
	  case MU_SDMSG: aqueue(TRUE,e,aparm);	break;
	  case MU_MUTEX: amutex(e,aparm);	break;
	}
	return(e->e_mask);
}


	UWORD
apret(mask)
	REG EVSPEC	mask;
{
	REG EVB		*p, *q;
	UWORD		erret;
						/* first find the event	*/
						/*   on the process list*/
	for (p = (q = (EVB *) &rlr->p_evlist) -> e_nextp; p;
						 p = (q=p)->e_nextp)
	  if (p->e_mask == mask) 
	    break;
						/* found the event,	*/
						/*   remove it from the	*/
						/*   zombie list 	*/
	p->e_pred->e_link = p->e_link;
	if ( p->e_link )
	  p->e_link->e_pred = p->e_pred;
	q->e_nextp = p->e_nextp;
	rlr->p_evbits &= ~mask;
	rlr->p_evwait &= ~mask;
	rlr->p_evflg &= ~mask;

	erret = LOWORD(p->e_return);

	p->e_nextp = eul;
	eul = p;

	return( erret );
}

	EVSPEC
acancel(m)
	EVSPEC		m;
{
	REG EVSPEC	m1;			/* mask of items not	*/
						/*   cancelled		*/
	REG WORD	f;
	REG EVB		*p, *q;

	m1 = 0;
	for (p = (q = (EVB *) &rlr->p_evlist)->e_nextp; p; p = (q=p)->e_nextp)
	{
	  if ( p->e_mask & m )
	  {
						/* take it off, if not	*/
						/*   completed or in-	*/
						/*   progress 		*/
	    f = p->e_flag;
	    if ( (f & NOCANCEL) || (f & COMPLETE) )
	      m1 |= p->e_mask;
	    else
	    {
	      q->e_nextp = p->e_nextp;
	      takeoff(p);
	      rlr->p_evbits &= ~p->e_mask;
	      rlr->p_evwait &= ~p->e_mask;
	      p = q;				/* contine traversal	*/
	    }
	  }
	}
	return(m1);
}

