/*****************************************************************************
portab.h	Digital Research's "portable" C definitions		PORTAB

*   Copyright 1999, Caldera Thin Client Systems, Inc.                       *
*   This software is licensed under the GNU Public License                  *
*   For further information, please see LICENSE.TXT                         *
*                                                                           *
*   Historical Copyright                                                    *
*                                                                           *
******************************************************************************
	 Copyright (c) 1985,1988,1991 Digital Research Inc.  
All rights reserved. The Software Code contained in this listing is
proprietary to Digital Research Inc., Monterey, California, and is covered by
U.S. and other copyright protection. Unauthorized copying, adaption,
distribution, use or display is prohibited and may be subject to civil and
criminal penalties.  Disclosure to others is prohibited. For the terms and
conditions of software code use, refer to the appropriate Digital Research
License Agreement.
			U.S. GOVERNMENT RESTRICTED RIGHTS 
This software product is provided with RESTRICTED RIGHTS.  Use, duplication or
disclosure by the Government is subject to restrictions as set forth in FAR
52.227-19 (c) (2) (June, 1987) when applicable or the applicable provisions of
the DOD FAR supplement 252.227-7013 subdivision (b) (3) (ii) (May, 1981) or
subdivision (c) (1) (ii) (May, 1987).  Contractor/manufacturer is Digital
Research Inc. / 70 Garden Court / BOX DRI / Monterey, CA 93940.
*******************************************************************************
$Header: m:/davinci/users//groups/panther/aes/rcs/portab.h 4.1 92/01/06 11:58:45 sbc Exp $
Date	Who	SPR#	Comments 
------- ------- ----	------------------------------------------------------
910402	WHF		Who made LONG unsigned?  
910313	WHF		TurboC cleanup 
881122	Frotz	----	Added 1988 Headers, RCS $HEADER$.
*****************************************************************************/

/************************************************************************
* File:		portab.h
*
* Description:	Contains DRI's portable C definitions.
*
* Build Info:	See the files that include this file for more information.
*
* Overview:	none.
*
************************************************************************/

/*
 *	Standard type definitions
 */
#define	BYTE	char				/* Signed byte		   */
#define BOOLEAN	int				/* 2 valued (true/false)   */
#define	WORD	int  				/* Signed word (16 bits)   */
#define	UWORD	unsigned int			/* unsigned word	   */

#define	LONG	signed long			/* signed long (32 bits)   */
#define	ULONG	unsigned long			/* Unsigned long	   */

#define	REG	register			/* register variable	   */
#define	EXTERN	extern				/* External variable	   */
#define	MLOCAL	static				/* Local to module	   */
#define	GLOBAL	/**/				/* Global variable	   */
#define	VOID	void				/* Void function return	   */
#define UBYTE	char

/****************************************************************************/
/*	Miscellaneous Definitions:					    */
/****************************************************************************/
#define	NULL	0			/*	Null pointer value	    */
#define NULLPTR ((void *) 0)		/*				    */
#define	TRUE	(1)			/*	Function TRUE  value	    */
#define	FALSE	(0)			/*	Function FALSE value	    */

/*
*	EOF:	portab.h
*/
